<template>
  <div>
    <!-- 左侧树形结构 -->
    <el-container>
      <el-aside width="300px">
        <div class="JKWTree-tree">
          <h3>其他计件单据维护</h3>
          <el-tree :data="treeData" :props="defaultProps" highlight-current="true"
            @node-click="handleNodeClick"></el-tree>
        </div>
      </el-aside>

      <el-container>
        <el-main>
          <!-- 按钮区域 -->
          <div class="gva-table-box">
            <div class="gva-btn-list">
              <el-row :span="6">
                <el-input v-model="searchInfo" placeholder="输入工单编号或产品名称" />
              </el-row>
              <el-button type="primary" :icon="Search" @click="onSearch">搜索</el-button>
              <el-button type="primary" :icon="Refresh">重置</el-button>
              <div style="margin-left: auto;">
                <el-button type="primary" :icon="Download" @click="exportExcel">导出到Excel</el-button>
              </div>
            </div>
            <!-- 数据展示 -->
            <el-table ref="multipleTable" style="width: 100%" tooltip-effect="dark" :data="tableData" row-key="ID"
              highlight-current-row="true" border @selection-change="handleSelectionChange" @row-dblclick="doubleClick">
              <el-table-column type="selection" width="55" />
              <el-table-column align="left" prop="sczl_Type" label="计件类型" width="100" />
              <el-table-column align="left" prop="Sczl_rq" label="日期" width="100" />
              <el-table-column align="left" prop="Sczl_bh1" label="员工编号" width="100" />
              <el-table-column align="left" prop="name" label="员工姓名" width="100" />
              <el-table-column align="left" prop="sczl_gdbh" label="工单编号" width="100" />
              <el-table-column align="left" prop="Gd_cpmc" label="产品名称" width="300" />
              <el-table-column align="left" prop="Sczl_cl" label="产量" width="100" />
              <el-table-column align="left" prop="" label="千件工价" width="100" />
              <el-table-column align="left" prop="" label="工价备注" width="200" />
              <el-table-column align="left" prop="Sczl_desc" label="备注" width="100" />
              <el-table-column align="left" prop="Sczl_gxmc" label="工序名称" width="100" />
              <el-table-column align="left" prop="sczl_yjno" label="印件号" width="100" />
              <el-table-column align="left" prop="sczl_gxh" label="工序号" width="100" />
              <el-table-column align="left" prop="sys_id" label="创建用户" width="150" />
              <el-table-column align="left" prop="sys_rq" label="创建时间" width="200" />
              <el-table-column align="left" prop="mod_rq" label="修改时间" width="200" />
              <el-table-column align="left" prop="UniqId" label="UNIQID" width="100" />
            </el-table>
            <!-- 分页 -->
            <div class="gva-pagination">
              <el-pagination layout="total, sizes, prev, pager, next, jumper" :current-page="page" :page-size="limit"
                :page-sizes="[10, 30, 50, 100]" :total="total" @current-change="handleCurrentChange"
                @size-change="handleSizeChange" />
            </div>
          </div>
          <!-- 弹出框 -->
          <el-dialog v-model="dialogFormVisible" :before-close="closeDialog" title="拉料计件产量维护" destroy-on-close
            width="800px">
            <!-- <el-scrollbar height="500px"> -->
            <el-form :model="formData" label-position="left" ref="elFormRef" :rules="rule">

              <el-row>
                <el-col>
                  <el-form-item label="员工编号" prop="name">
                    <el-col :span="4">
                      <el-input v-model="formData.image" :clearable="true" placeholder="ZM00408" />
                    </el-col>
                    <el-col :span="6" style="margin-left: 10px;">
                      <el-input v-model="formData.image" :clearable="true" placeholder="李有文" />
                    </el-col>
                  </el-form-item>
                </el-col>
              </el-row>

              <el-row>
                <el-col :span="8">
                  <el-form-item label="工序类别" prop="name">
                    <el-input v-model="formData.image" :clearable="true" placeholder="拉料" />
                  </el-form-item>
                </el-col>

                <el-col :span="6" style="margin-left: 5px;">
                  <el-form-item label="日期" prop="name">
                    <el-input v-model="formData.image" :clearable="true" placeholder="2022/04/08" />
                  </el-form-item>

                </el-col>
              </el-row>

              <el-row>
                <el-col>
                  <el-form-item label="工单编号" prop="name">
                    <el-col :span="4">
                      <el-input v-model="formData.image" :clearable="true" placeholder="2203217" />
                    </el-col>
                    <el-col :span="16" style="margin-left: 10px;">
                      <el-input v-model="formData.image" :clearable="true" placeholder="黄山金院烟 条盒" />
                    </el-col>
                  </el-form-item>
                </el-col>
              </el-row>

              <el-row>
                <el-col>
                  <el-form-item label="工艺流程" prop="name">
                    <el-col :span="10">
                      <el-input v-model="formData.image" :clearable="true" placeholder="" />
                    </el-col>
                    <el-col :span="4" style="margin-left: 10px;">
                      <el-input v-model="formData.image" :clearable="true" placeholder="0" />
                    </el-col>
                  </el-form-item>
                </el-col>
              </el-row>

              <el-row>
                <el-col :span="10">
                </el-col>
                <el-col :span="8" style="margin-left: 5px;">
                  <el-form-item label="计件产量" prop="name">
                    <el-input v-model="formData.image" :clearable="true" placeholder="30.00" />
                  </el-form-item>
                </el-col>
              </el-row>

              <el-row>
                <el-col>
                  <el-form-item label="工价代号" prop="name">
                    <el-col :span="6">
                      <el-input v-model="formData.image" :clearable="true" placeholder="030010003008" />
                    </el-col>
                    <el-col :span="14" style="margin-left: 10px;">
                      <el-input v-model="formData.image" :clearable="true" placeholder="原纸仓库--->度印车间" />
                    </el-col>
                  </el-form-item>
                </el-col>
              </el-row>

              <el-row>
                <el-col>
                  <el-form-item label="票号备注" prop="name">
                    <el-col :span="20">
                      <el-input v-model="formData.image" :clearable="true" placeholder="1-30" />
                    </el-col>
                    <el-col :span="0" style="margin-left: 10px;">
                      <el-input v-model="formData.image" :clearable="true" placeholder="原纸仓库--->度印车间" />
                    </el-col>
                  </el-form-item>
                </el-col>
              </el-row>

            </el-form>

            <template #footer>
              <div class="dialog-footer">
                <el-button @click="closeDialog">取 消</el-button>
                <el-button type="primary" @click="enterDialog">确 定</el-button>
              </div>
            </template>
          </el-dialog>

        </el-main>
      </el-container>
    </el-container>

  </div>
</template>

<script setup>
import {
  createCompany,
  deleteCompany,
  deleteCompanyByIds,
  updateCompany,
  findCompany,
  getCompanyList
} from '@/api/company'

// 全量引入格式化工具 请按需保留
import { getDictFunc, formatDate, formatBoolean, filterDict, ReturnArrImg, onDownloadFile } from '@/utils/format'
import { ElMessage, ElMessageBox } from 'element-plus'
import { Search, Refresh, Download } from '@element-plus/icons-vue'
import { ref, reactive, onMounted, onBeforeMount } from 'vue'
import { getOtherSideTable, getOtherTable } from '@/api/mes_api_gty/myapi'


defineOptions({
  name: '07-otherDocuments'
})

// 侧边栏数据请求
const treeData = reactive([]);
const getSideData = async () => {
  const response = await getOtherSideTable();
  if (response.code === 0) {
    const transformedData = response.data.map(item => ({
      label: `${item.date.replace(/-/g, '.')}【产量合计: ${item.counts}】`,
      children: item.sys.map(sysItem => ({
        label: `${sysItem.Sczl_bh1}(${sysItem.name}) 【产量合计: ${sysItem.count}】`,
        params: {
          date: item.date.substring(0, 4) + '-' + item.date.substring(4),
          Sczl_bh1: sysItem.Sczl_bh1,
        },
      })),
    }));
    treeData.splice(0, treeData.length, ...transformedData);
  }
};
getSideData();




// 自动化生成的字典（可能为空）以及字段
const formData = ref({
  jjlx: '',
  rq: '',
  ygbh: '',
  ygxm: '',
  gdbh: '',
  cpmc: '',
  cl: '',
  qjgj: '',
  gjbz: '',
  bz: '',
  gxmc: '',
  yjh: '',
  gxh: '',
  cjyh: '',
  cjsj: '',
  xgsj: '',
  uid: '',
})

// 验证规则
const rule = reactive({
})

const elFormRef = ref()
const elSearchFormRef = ref()

// =========== 表格控制部分 ===========
const tableData = reactive([])
const page = ref(1)
const total = ref(0)
const limit = ref(10)
const searchInfo = ref('')
const params = {
  date: '',
  Sczl_bh1: '',
  page: page.value.toString(),
  limit: limit.value.toString(),
}


// 分页设置
const handleSizeChange = (val) => {
  limit.value = val;
  params.limit = val.toString();
  getTableData();
}

// 页面跳转
const handleCurrentChange = (val) => {
  page.value = val;
  params.page = val.toString();
  getTableData();
}

const getTableData = async () => {
  const response = await getOtherTable(params)
  if (response.code === 0) {
    total.value = response.data.total;
    tableData.splice(0, tableData.length, ...response.data.rows);
  }
}

const handleNodeClick = (node, check) => {
  if (node.params) {
    params.date = node.params.date;
    params.Sczl_bh1 = node.params.Sczl_bh1;
    handleCurrentChange(1);
  }
}

// 搜索
function onSearch() {
}
// ============== 表格控制部分结束 ===============

// 获取需要的字典 可能为空 按需保留
const setOptions = async () => {
}

// 获取需要的字典 可能为空 按需保留
setOptions()

// 多选数据
const multipleSelection = ref([])
// 多选
const handleSelectionChange = (val) => {
  multipleSelection.value = val
}

// 批量删除控制标记
const deleteVisible = ref(false)

// 多选删除
const onDelete = async () => {
  const ids = []
  if (multipleSelection.value.length === 0) {
    ElMessage({
      type: 'warning',
      message: '请选择要删除的数据'
    })
    return
  }
  multipleSelection.value &&
    multipleSelection.value.map(item => {
      ids.push(item.ID)
    })
  const res = await deleteCompanyByIds({ ids })
  if (res.code === 0) {
    ElMessage({
      type: 'success',
      message: '删除成功'
    })
    if (tableData.value.length === ids.length && page.value > 1) {
      page.value--
    }
    deleteVisible.value = false
    getTableData()
  }
}

// 行为控制标记（弹窗内部需要增还是改）
const type = ref('')

// 更新行
const updateCompanyFunc = async (row) => {
  const res = await findCompany({ ID: row.ID })
  type.value = 'update'
  if (res.code === 0) {
    formData.value = res.data.recompany
    dialogFormVisible.value = true
  }
}

// 弹窗控制标记
const dialogFormVisible = ref(false)

// 打开弹窗
const openDialog = () => {
  type.value = 'create'
  dialogFormVisible.value = true
}

// 关闭弹窗
const closeDialog = () => {
  dialogFormVisible.value = false
  formData.value = {
    address: '',
    image: '',
    name: '',
  }
}
// 弹窗确定
const enterDialog = async () => {
  elFormRef.value?.validate(async (valid) => {
    if (!valid) return
    let res
    switch (type.value) {
      case 'create':
        res = await createCompany(formData.value)
        break
      case 'update':
        res = await updateCompany(formData.value)
        break
      default:
        res = await createCompany(formData.value)
        break
    }
    if (res.code === 0) {
      ElMessage({
        type: 'success',
        message: '创建/更改成功'
      })
      closeDialog()
      getTableData()
    }
  })
}

// 双击表格操作
function doubleClick(row, column, event) {
  console.log(row, column, event);
  // updateCompanyFunc(row);
  type.value = 'update';
  dialogFormVisible.value = true
}

// 导出excel
function exportExcel() {
  console.log('导出到excel');
}

// 生命周期钩子
onMounted(() => {
});
</script>

<style scoped>
.JKWTree-container {
  display: flex;
}

.JKWTree-tree {
  width: 300px;
  background-color: #fff;
  padding: 10px;
  margin-right: 20px;
}

.JKWTree-tree h3 {
  font-size: 15px;
  font-weight: 700;
  margin: 10px 0;
}

.JKWTree-content {
  flex: 1;
}

/* 选中某行时的背景色*/
::v-deep .el-table__body tr.current-row>td {
  background: #ff80ff !important;
}
</style>
